proc setHints { } {
	global hint
set hint(.mb.edit.m,8) {ungroup selected objects (Shft+Ctl+G)}
set hint(.bar.ovalf) {filled ellipse object}
set hint(.bar.front) {bring selected object(s) to the front}
set hint(.bar.oval) {hollow ellipse object}
set hint(.mb.objects.m,10) {slide show}
set hint(.bar.line) {line object}
set hint(.mb.layout.m,11) {page layout popup}
set hint(.mb.help.m,1) {about Slidedraw}
set hint(.bar.paste) {paste object(s) to the canvas (Ctl+V)}
set hint(.mb.layout.m,1) {select font family}
set hint(.mb.layout.m,2) {select font size}
set hint(.mb.help) {help menu (about)}
set hint(.mb.layout.m,4) {choose color palette...}
set hint(.mb.objects) {objects menu (line, frame, filled frame,...)}
set hint(.mb.layout.m,5) {select line width}
set hint(.mb.layout.m,6) {select line style}
set hint(.mb.layout.m,7) {set text alignment}
set hint(.mb.layout.m,8) {snap - select grid cell size}
set hint(.mb.layout.m,9) {set background pattern}
set hint(.bar.box) {filled frame object}
set hint(.mb.file) {file operations menu (new, open, merge,...)}
set hint(.bar.cut) {cut currently selected object(s) (Ctl+C)}
set hint(.mb.edit) {edit menu (cut, paste, front, back....)}
set hint(.bar.back) {send selected object(s) to back}
set hint(.bar.boxed) {multiline text bounded by a box}
set hint(.bar.image) {insert an image object (.gif,.xpm,.pbm)}
set hint(.mb.objects.m,1) {draw a line}
set hint(.mb.objects.m,2) {draw a frame}
set hint(.mb.objects.m,3) {draw a filled frame}
set hint(.mb.objects.m,4) {draw an ellipse}
set hint(.mb.objects.m,5) {draw a filled ellipse}
set hint(.mb.objects.m,6) {write text}
set hint(.mb.file.m,1) {load a slide from disk (Ctl+L)}
set hint(.mb.objects.m,7) {write boxed text}
set hint(.bar.copy) {copy selected object(s) (Ctl+C)}
set hint(.mb.file.m,2) {create a new blank slide (Ctl+N)}
set hint(.mb.objects.m,8) {insert an image object (.gif,.xpm,.pbm)}
set hint(.mb.file.m,3) {merge current slide with a loaded one}
set hint(.bar.text) {writes text object}
set hint(.mb.file.m,4) {save current slide as... (Ctl+S)}
set hint(.mb.file.m,5) {export current slide to PostScript}
set hint(.mb.file.m,6) {print current slide}
set hint(.mb.layout) {layout menu (font, page, others...)}
set hint(.mb.edit.m,1) {copy selected object(s) (Ctl+C)}
set hint(.mb.file.m,8) {quit program (Ctl+q)}
set hint(.mb.edit.m,2) {paste object(s) to the canvas (Ctl+V)}
set hint(.mb.edit.m,3) {cut currently selected object(s) (Ctl+C)}
set hint(.bar.frame) {hollow frame object}
set hint(.mb.edit.m,5) {bring selected object(s)to front (Ctl+F)}
set hint(.mb.edit.m,6) {send selected object(s)to back (Ctl+B)}
set hint(.mb.edit.m,7) {group selected objects (Ctl+G)}
}

proc canvasBind { } {
	global sld hint xtopadd ytopadd
#### binding for object motion
	.c.c bind slide <3> {objectStartMove %x %y}
	.c.c bind slide <B3-Motion> {objectMove %x %y}
	.c.c bind slide <Motion> {objectResize %x %y}
	.c.c bind slide <Leave> {.c.c config -cursor $sld(cursor)}
	.c.c bind slide <Control-3> {objectSelectAdd %x %y}
	.c.c bind slide <Double-3> {objectOptions %x %y}

#### keyboard accelerators
	bind kbdAccelerator <Page_Up> prevSlide
	bind kbdAccelerator  <Page_Down> nextSlide
	bind kbdAccelerator <Control-n> fileNew
	bind kbdAccelerator <Control-s> fileSave
	bind kbdAccelerator <Control-l> fileLoad
	bind kbdAccelerator <Control-q> "saveConfig; exit"
	bind kbdAccelerator <Control-v> pasteObject
	bind kbdAccelerator <Control-c> copyObject
	bind kbdAccelerator <Control-x> cutObject
	bind kbdAccelerator <Control-f> frontObject
	bind kbdAccelerator <Control-b> backObject
	bind kbdAccelerator <Control-g> groupObjects
	bind kbdAccelerator <Control-Shift-G> ungroupObjects
### create a binding tag for the keyboard accelerators
	set tags [bindtags .]
	bindtags . [linsert $tags 0 kbdAccelerator]
#### Just for when we have the Presentation mode...
####	bind . <Control-F7> slidePresentation

## not canvas related, but updates status line for each button or menu
## entered (a simple context sensitive help)
	bind Button <Enter> {+showHints %W}
	bind Menubutton <Enter> {+showHints %W}
	bind Menu <Motion> {+showHints %W %y}
##
## ## for internal use (development) -- saves hinted objects ##
## Procedure for editing hints (short helps):
## (1) uncomment binding below; start slidedraw;
## (2) navigate for all buttons, to be sure its hint skeleton
## will be generated;
## (3) save "hints.dat" file, by doing <Control-z>;
## (4) edit this file to replace window or menu entry with help text
## desired;
## (5) modify proc setHints above to include all edited text;
## (6) comment again the binding below (so the user will not access it :)
#bind . <Control-z> {saveHints}

	setHints

	wm minsize . 200 150
	tkwait visibility .

## get the margins to add to canvas geometry
	regexp {([0-9]*)x([0-9]*)\+.*} \
		[wm geometry .] all topwidth topheight rest
	set xtopadd [expr $topwidth - $sld(width)]
	set ytopadd [expr $topheight - $sld(height)]

## bind resize of toplevel, so we could resize also the canvas
bind . <Configure> {+resizeCanvas}

## binding for moving the rulers
bind .c.cscrollh <ButtonRelease> {+moveRulers}
bind .c.cscrollv <ButtonRelease> {+moveRulers}
bind .c.cscrollh <Leave> {+moveRulers}
bind .c.cscrollv <Leave> {+moveRulers}

makeRulers
}

proc saveHints { } {
	global hint
	set f [open hints.dat w]
	foreach n [array names hint] {
		puts $f "set hint($n) \{$hint($n)\}"
	}
	close $f
}

#
# doBindings -- modify canvas bindings so that kind of object is concerned
# also sets cursor to reflect which objects will be inserted
#
proc doBindings {t} {
	global fillbox boxedtext
	switch $t {
	slideshow {
		setCursor star
		bind .c.c <1> {nextSlide}
		bind .c.c <3> {prevSlide}
	}
	line {
		setCursor tcross
		bind .c.c <1> {insertLine %x %y} 
		bind .c.c <B1-Motion> {insertLineMove %x %y} 
		bind .c.c <ButtonRelease-1> {insertLineEnd %x %y}
	}
	frame { 
		setCursor ul_angle
		set fillbox 0
		bind .c.c <1> {insertLine %x %y} 
		bind .c.c <ButtonRelease-1> {insertBoxEnd %x %y} 
		bind .c.c <B1-Motion> {insertBoxMove %x %y}
	}
	box {
		setCursor ul_angle
		set fillbox 1
		bind .c.c <1> {insertLine %x %y} 
		bind .c.c <ButtonRelease-1> {insertBoxEnd %x %y} 
		bind .c.c <B1-Motion> {insertBoxMove %x %y}
	}
	ellipse {
		setCursor ul_angle
		set fillbox 0
		bind .c.c <1> {insertLine %x %y} 
		bind .c.c <ButtonRelease-1> {insertEllipseEnd %x %y} 
		bind .c.c <B1-Motion> {insertEllipseMove %x %y}
	}
	fellipse {
		setCursor ul_angle
		set fillbox 1
		bind .c.c <1> {insertLine %x %y} 
		bind .c.c <ButtonRelease-1> {insertEllipseEnd %x %y} 
		bind .c.c <B1-Motion> {insertEllipseMove %x %y}
	}
	text {
		setCursor xterm
		set boxedtext 0
		bind .c.c <1> {insertTextMark %x %y}
		bind .c.c <ButtonRelease-1> {insertTextLimit %x %y}
		bind .c.c <B1-Motion> {insertTextDrag %x %y}
	}
	btext {
		setCursor xterm
		set boxedtext 1
		bind .c.c <1> {insertTextMark %x %y}
		bind .c.c <ButtonRelease-1> {insertTextLimit %x %y}
		bind .c.c <B1-Motion> {insertTextDrag %x %y}
	}
	image {
		setCursor draped_box
		bind .c.c <1> {insertImage %x %y} 
		bind .c.c <ButtonRelease-1> {}
		bind .c.c <B1-Motion> {}
	}
	}
}

